#!/bin/bash
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin;

#----------↓配置信息区域↓----------#

#数据库root密码
mysql_password="0d8f47eb86f2c51c";

#备份存储位置类型（local：本地，remote：远程linux服务器，aliyun：阿里云OSS，qcloud：腾讯云COS，huawei：华为云OBS，baidu：百度云BOS，qiniu：七牛云）
backup_type="local";

#远程服务器IP
remote_server_ip="10.0.5.10";
#远程服务器登录用户名
remote_server_user="root";
#远程服务器保存路径
remote_server_path="/home/backup";

#云存储的bucket名称
cloud_bucket="cccyun";
#云存储的存储路径
cloud_path="/backup/";

#----------↑配置信息区域↑----------#


echo -e "————————————————————————————————————————————————————
	\033[32mKangle一键备份脚本\033[0m
	Powered By 彩虹
————————————————————————————————————————————————————"
echo '';


if [ $(whoami) != "root" ];then
	echo "请使用root权限执行命令！"
	exit 1;
fi
if [ ! -f /vhs/kangle/bin/kangle ];then
	echo "未安装Kangle"
	exit 1
fi
if [ ! -f /usr/bin/innobackupex ]; then
	echo "未安装 XtraBackup，无法继续执行备份脚本。";
	exit 1;
fi


DateTag=`date +%Y%m%d-%H%M%S`;
backup_file="${DateTag}.tgz";
mkdir -p /home/backup/${DateTag}/;

echo "[Notice] Backup ftp.";
cd /home;
tar -czvf /home/backup/${DateTag}/ftp.tgz ftp --exclude *.log --exclude *.7z --exclude *.rar --exclude *.zip --exclude *.gz;

echo "[Notice] Backup mysql.";
innobackupex --user=root --password=$mysql_password --stream=tar ./ | gzip - > /home/backup/${DateTag}/mysql.tgz

echo "[Notice] Backup vhs.db.";
cd /vhs/kangle/;
tar -czvf /home/backup/${DateTag}/etc.tgz etc

cd /home/backup/;

if [ "$backup_type" = "remote" ]; then

	remote_server="${remote_server_user}@${remote_server_ip}:${remote_server_path}";
	echo "[Notice] Upload to remote server: \"${remote_server}\", please wait.";

	scp -r /home/backup/${DateTag} ${remote_server};
	rm -rf /home/backup/${DateTag};

	echo -e "\033[32mUpload to remote server: \"${remote_server}\" success.\033[0m";

elif [ "$backup_type" = "aliyun" ]; then

	oss_path="oss://${cloud_bucket}${cloud_path}";
	echo "[Notice] Upload to Aliyun OSS: \"${oss_path}\", please wait.";

	ossutil cp -r /home/backup/${DateTag} ${oss_path}${DateTag}/ --retry-times=5;
	rm -rf /home/backup/${DateTag};

	echo -e "\033[32mUpload to Aliyun OSS: \"${oss_path}\" success.\033[0m";

elif [ "$backup_type" = "qcloud" ]; then

	cos_path="cos://${cloud_bucket}${cloud_path}";
	echo "[Notice] Upload to Qcloud COS: \"${cos_path}\", please wait.";

	coscli cp -r /home/backup/${DateTag} ${cos_path}${DateTag}/;
	rm -rf /home/backup/${DateTag};

	echo -e "\033[32mUpload to Qcloud COS: \"${cos_path}\" success.\033[0m";

elif [ "$backup_type" = "huawei" ]; then

	obs_path="obs://${cloud_bucket}${cloud_path}";
	echo "[Notice] Upload to HuaweiCloud OBS: \"${obs_path}\", please wait.";

	obsutil cp -r -f /home/backup/${DateTag} ${obs_path}${DateTag}/;
	rm -rf /home/backup/${DateTag};

	echo -e "\033[32mUpload to HuaweiCloud OBS: \"${obs_path}\" success.\033[0m";

elif [ "$backup_type" = "baidu" ]; then

	bos_path="bos:/${cloud_bucket}${cloud_path}";
	echo "[Notice] Upload to BaiduCloud BOS: \"${bos_path}\", please wait.";

	bcecmd bos cp -r /home/backup/${DateTag}/ ${bos_path}${DateTag}/;
	rm -rf /home/backup/${DateTag};

	echo -e "\033[32mUpload to BaiduCloud BOS: \"${bos_path}\" success.\033[0m";

elif [ "$backup_type" = "qiniu" ]; then

	echo "[Notice] Upload to Qiniu Kodo: \"${cloud_bucket}\", please wait.";

	qshell qupload2 --src-dir=/home/backup/${DateTag}/ --bucket=${cloud_bucket} --key-prefix=${cloud_path}${DateTag}/
	rm -rf /home/backup/${DateTag};

	echo -e "\033[32mUpload to Qiniu Kodo: \"${cloud_bucket}\" success.\033[0m";

fi

# crontab -e
# 0 2 * * * /root/backup.sh >/root/backup.log 2>&1