#!/bin/bash
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin;

#----------↓配置信息区域↓----------#

#数据库root密码
mysql_password="0d8f47eb86f2c51c";

#----------↑配置信息区域↑----------#


echo -e "————————————————————————————————————————————————————
	\033[32mKangle一键还原脚本\033[0m
	Powered By 彩虹
————————————————————————————————————————————————————"
echo '';


if [ $(whoami) != "root" ];then
	echo "请使用root权限执行命令！"
	exit 1;
fi
if [ ! -f /vhs/kangle/bin/kangle ];then
	echo "未安装Kangle"
	exit 1
fi
if [ ! -f /usr/bin/innobackupex ]; then
	echo "未安装 XtraBackup，无法继续执行备份还原脚本。";
	exit 1;
fi


BACKUP_DIR=`pwd`;
if [ "$1" != "" ]; then
	BACKUP_DIR=$1;
fi

if [ ! -f "$BACKUP_DIR/etc.tgz" ] || [ ! -f "$BACKUP_DIR/ftp.tgz" ]; then
	echo "$BACKUP_DIR 目录下未找到备份文件，无法继续执行备份还原脚本。请将本脚本放到备份文件目录下执行，或使用 ./restore.sh [DIR]";
	exit 1;
fi

VHOST_COUNT=`sqlite3 /vhs/kangle/etc/vhs.db <<EOF
select count(*) from vhost;
EOF`
if [ "$VHOST_COUNT" -gt "0" ]; then
	echo -e "\033[33m数据安全检查失败：请进入EP面板删除全部网站之后再执行备份还原脚本。\033[0m";
	exit 1;
fi

echo "备份还原操作将清空当前服务器全部已有的数据库和网站文件！"
read -p "输入y确认继续执行备份还原: " yes;
if [ "$yes" != "y" ] && [ "$yes" != "Y" ];then
	echo "------------"
	echo "已取消备份还原"
	exit;
fi

if [ -f "$BACKUP_DIR/mysql.tgz" ]; then
MYSQL_DIR="/home/mysql";
if [ ! -d $MYSQL_DIR ]; then
	MYSQL_DIR="/var/lib/mysql";
	if [ ! -d $MYSQL_DIR ]; then
		echo "[Error] 未找到MySQL数据库安装位置！如不需要还原数据库，请删除mysql.tgz";
		exit 1;
	fi
fi
echo "----------------------------------------------------"
echo "[Notice] 开始还原MySQL数据库";
service mysqld stop
sleep 0.5
rm -rf $MYSQL_DIR/*;
tar zxvf mysql.tgz -C $MYSQL_DIR;
innobackupex --user=root --password=$mysql_password --apply-log $MYSQL_DIR
chown -R mysql:mysql $MYSQL_DIR
service mysqld start
if test $? != 0; then
	echo "----------------------------------------------------"
	echo "[Error] MySQL数据库还原失败。"
	exit 1;
fi
fi

echo "----------------------------------------------------"
echo "[Notice] 开始还原ftp网站文件";
tar zxvf ftp.tgz -C /home;

echo "----------------------------------------------------"
echo "[Notice] 开始还原etc配置文件";
/vhs/kangle/bin/kangle -q
sleep 0.5
tar zxvf etc.tgz -C /vhs/kangle;
/vhs/kangle/bin/kangle

echo "----------------------------------------------------"
echo -e "\033[32m备份还原已完成！\033[0m";
echo "----------------------------------------------------"
